diff --git a/CMakeLists.txt b/CMakeLists.txt
index 0d03e1859..9d0cd52d6 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -288,28 +288,6 @@ target_include_directories(giflib
     PRIVATE ${GIFLIB_DIR}
     INTERFACE ${THIRDPARTY_DIR}/giflib)
 
-################################
-# ZLIB
-################################
-
-set(ZLIB_DIR ${THIRDPARTY_DIR}/zlib)
-set(ZLIB_SRC 
-    ${ZLIB_DIR}/adler32.c
-    ${ZLIB_DIR}/compress.c
-    ${ZLIB_DIR}/crc32.c
-    ${ZLIB_DIR}/deflate.c
-    ${ZLIB_DIR}/inflate.c
-    ${ZLIB_DIR}/infback.c
-    ${ZLIB_DIR}/inftrees.c
-    ${ZLIB_DIR}/inffast.c
-    ${ZLIB_DIR}/trees.c
-    ${ZLIB_DIR}/uncompr.c
-    ${ZLIB_DIR}/zutil.c
-)
-
-add_library(zlib STATIC ${ZLIB_SRC})
-target_include_directories(zlib INTERFACE ${THIRDPARTY_DIR}/zlib)
-
 ################################
 # TIC-80 core
 ################################
@@ -342,7 +320,7 @@ target_include_directories(tic80core
     PUBLIC 
         ${CMAKE_CURRENT_BINARY_DIR})
 
-target_link_libraries(tic80core lua lpeg wren squirrel giflib zlib)
+target_link_libraries(tic80core lua lpeg wren squirrel giflib)
 
 if(LINUX)
     target_link_libraries(tic80core m)
@@ -599,6 +577,28 @@ set(CURL_CA_PATH "none" CACHE STRING "")
 add_subdirectory(${THIRDPARTY_DIR}/curl)
 endif()
 
+################################
+# ZLIB
+################################
+
+set(ZLIB_DIR ${THIRDPARTY_DIR}/zlib)
+set(ZLIB_SRC 
+    ${ZLIB_DIR}/adler32.c
+    ${ZLIB_DIR}/compress.c
+    ${ZLIB_DIR}/crc32.c
+    ${ZLIB_DIR}/deflate.c
+    ${ZLIB_DIR}/inflate.c
+    ${ZLIB_DIR}/infback.c
+    ${ZLIB_DIR}/inftrees.c
+    ${ZLIB_DIR}/inffast.c
+    ${ZLIB_DIR}/trees.c
+    ${ZLIB_DIR}/uncompr.c
+    ${ZLIB_DIR}/zutil.c
+)
+
+add_library(zlib STATIC ${ZLIB_SRC})
+target_include_directories(zlib INTERFACE ${THIRDPARTY_DIR}/zlib)
+
 ################################
 # ZIP
 ################################
@@ -688,7 +688,7 @@ target_include_directories(${TIC80_OUTPUT}lib PRIVATE
     ${CMAKE_SOURCE_DIR}/include
     ${THIRDPARTY_DIR}/curl/include)
 
-target_link_libraries(${TIC80_OUTPUT}lib tic80core libcurl zip)
+target_link_libraries(${TIC80_OUTPUT}lib tic80core zlib libcurl zip)
 
 if(BUILD_PRO)
     target_compile_definitions(tic80lib PRIVATE TIC80_PRO)
diff --git a/src/code.c b/src/code.c
index edacb7cdf..f960b3841 100644
--- a/src/code.c
+++ b/src/code.c
@@ -205,8 +205,18 @@ static void updateEditor(Code* code)
 
     // update status
     {
+        memset(code->status, ' ', sizeof code->status - 1);
+
+        char status[TEXT_BUFFER_WIDTH];
         s32 count = getLinesCount(code);
-        sprintf(code->status, "line %i/%i col %i", line + 1, count + 1, column + 1);
+        sprintf(status, "line %i/%i col %i", line + 1, count + 1, column + 1);
+        memcpy(code->status, status, strlen(status));
+
+        size_t codeLen = strlen(code->src);
+        sprintf(status, "%i/%i", (u32)codeLen, TIC_CODE_SIZE);
+
+        memset(code->src + codeLen, '\0', TIC_CODE_SIZE - codeLen);
+        memcpy(code->status + sizeof code->status - strlen(status) - 1, status, strlen(status));
     }
 }
 
diff --git a/src/config.c b/src/config.c
index 2ac25fd14..5845ada5a 100644
--- a/src/config.c
+++ b/src/config.c
@@ -296,14 +296,12 @@ static void setDefault(Config* config)
             #include "../build/assets/config.tic.dat"
         };
 
-        u8* embedBios = calloc(1, sizeof(tic_cartridge));
+        u8* embedBios = NULL;
+        s32 size = unzip((u8**)&embedBios, DefaultBiosZip, sizeof DefaultBiosZip);
 
         if(embedBios)
         {
-            s32 size = tic_tool_unzip(embedBios, sizeof(tic_cartridge), DefaultBiosZip, sizeof DefaultBiosZip);
-
-            if(size)
-                update(config, embedBios, size);
+            update(config, embedBios, size);
 
             free(embedBios);
         }
diff --git a/src/console.c b/src/console.c
index c859df19a..11b22257d 100644
--- a/src/console.c
+++ b/src/console.c
@@ -26,6 +26,7 @@
 #include "ext/gif.h"
 #include "ext/file_dialog.h"
 
+#include <zlib.h>
 #include <ctype.h>
 #include <string.h>
 #include <stddef.h>
@@ -97,8 +98,6 @@ typedef struct
 
 #endif
 
-static const char* CodeSizeError = "\nCompressed code size is greater than 64K";
-
 #if defined(__TIC_WINDOWS__)
 static const char* ExeExt = ".exe";
 #endif
@@ -595,14 +594,12 @@ static void* getDemoCart(Console* console, ScriptLang script, s32* size)
 #endif /* defined(TIC_BUILD_WITH_SQUIRREL) */
     }
 
-    u8* data = calloc(1, sizeof(tic_cartridge));
+    u8* data = NULL;
+    *size = unzip(&data, demo, romSize);
 
     if(data)
     {
-        *size = tic_tool_unzip(data, sizeof(tic_cartridge), demo, romSize);
-
-        if(*size)
-            fsSaveRootFile(console->fs, path, data, *size, false);
+        fsSaveRootFile(console->fs, path, data, *size, false);
     }
 
     return data;
@@ -784,7 +781,8 @@ static char* saveBinarySection(char* ptr, const char* comment, const char* tag,
     return ptr;
 }
 
-static const struct BinarySection{char* tag; s32 count; s32 offset; s32 size; bool flip;} BinarySections[] = 
+typedef struct {char* tag; s32 count; s32 offset; s32 size; bool flip;} BinarySection;
+static const BinarySection BinarySections[] = 
 {
     {"TILES",       TIC_BANK_SPRITES,   offsetof(tic_bank, tiles),          sizeof(tic_tile),           true},
     {"SPRITES",     TIC_BANK_SPRITES,   offsetof(tic_bank, sprites),        sizeof(tic_tile),           true},
@@ -806,26 +804,25 @@ static void makeTag(const char* tag, char* out, s32 bank)
 static s32 saveProject(Console* console, void* buffer, const char* comment)
 {
     tic_mem* tic = console->tic;
-    const tic_cartridge* cart = &tic->cart;
 
     char* stream = buffer;
-    char* ptr = saveTextSection(stream, cart->code.data);
+    char* ptr = saveTextSection(stream, tic->cart.code.data);
     char tag[16];
 
     for(s32 i = 0; i < COUNT_OF(BinarySections); i++)
     {
-        const struct BinarySection* section = &BinarySections[i];
+        const BinarySection* section = &BinarySections[i];
 
         for(s32 b = 0; b < TIC_BANKS; b++)
         {
             makeTag(section->tag, tag, b);
 
             ptr = saveBinarySection(ptr, comment, tag, section->count, 
-                (u8*)&cart->banks[b] + section->offset, section->size, section->flip);
+                (u8*)&tic->cart.banks[b] + section->offset, section->size, section->flip);
         }
-    }
+    }       
 
-    ptr = saveBinarySection(ptr, comment, "COVER", 1, &cart->cover, cart->cover.size + sizeof(s32), true);
+    ptr = saveBinarySection(ptr, comment, "COVER", 1, &tic->cart.cover, tic->cart.cover.size + sizeof(s32), true);
 
     return strlen(stream);
 }
@@ -975,27 +972,23 @@ static bool loadProject(Console* console, const char* name, const char* data, s3
             if(loadTextSection(project, comment, cart->code.data, sizeof(tic_code)))
                 done = true;
 
-            if(done)
+            for(s32 i = 0; i < COUNT_OF(BinarySections); i++)
             {
-                for(s32 i = 0; i < COUNT_OF(BinarySections); i++)
-                {
-                    const struct BinarySection* section = &BinarySections[i];
+                const BinarySection* section = &BinarySections[i];
 
-                    for(s32 b = 0; b < TIC_BANKS; b++)
-                    {
-                        makeTag(section->tag, tag, b);
+                for(s32 b = 0; b < TIC_BANKS; b++)
+                {
+                    makeTag(section->tag, tag, b);
 
-                        if(loadBinarySection(project, comment, tag, section->count, (u8*)&cart->banks[b] + section->offset, section->size, section->flip))
-                            done = true;
-                    }
+                    if(loadBinarySection(project, comment, tag, section->count, (u8*)&cart->banks[b] + section->offset, section->size, section->flip))
+                        done = true;
                 }
-
-                if(loadBinarySection(project, comment, "COVER", 1, &cart->cover, -1, true))
-                    done = true;
             }
+
+            if(loadBinarySection(project, comment, "COVER", 1, &cart->cover, -1, true))
+                done = true;
             
-            if(done)
-                memcpy(dst, cart, sizeof(tic_cartridge));
+            memcpy(dst, cart, sizeof(tic_cartridge));
 
             free(cart);
         }
@@ -1027,7 +1020,6 @@ static void updateProject(Console* console)
 
                     studioRomLoaded();
                 }
-                else printError(console, "\nproject updating error :(");
                 
                 free(cart);
             }
@@ -1081,12 +1073,17 @@ static void onConsoleLoadCommandConfirmed(Console* console, const char* param)
 
             void* data = fsLoadFile(console->fs, name, &size);
 
-            if(data && loadProject(console, name, data, size, &console->tic->cart))
+            if(data)
+            {
+                loadProject(console, name, data, size, &console->tic->cart);
                 onCartLoaded(console, name);
-            else printBack(console, "\ncart loading error");
 
-            if(data)
                 free(data);
+            }
+            else
+            {
+                printBack(console, "\ncart loading error");
+            }
         }
     }
     else printBack(console, "\ncart name is missing");
@@ -1416,17 +1413,10 @@ static void onConsoleClsCommand(Console* console, const char* param)
 
 static void installDemoCart(FileSystem* fs, const char* name, const void* cart, s32 size)
 {
-    u8* data = calloc(1, sizeof(tic_cartridge));
-
-    if(data)
-    {
-        s32 dataSize = tic_tool_unzip(data, sizeof(tic_cartridge), cart, size);
-
-        if(dataSize)
-            fsSaveFile(fs, name, data, dataSize, true);
-
-        free(data);        
-    }
+    u8* data = NULL;
+    s32 dataSize = unzip(&data, cart, size);
+    fsSaveFile(fs, name, data, dataSize, true);
+    free(data);
 }
 
 static void onConsoleInstallDemosCommand(Console* console, const char* param)
@@ -1914,14 +1904,14 @@ static void* embedCart(Console* console, s32* size)
         {
             s32 cartSize = tic_core_save(&tic->cart, cart);
 
-            if(cartSize)
             {
                 unsigned long zipSize = sizeof(tic_cartridge);
                 u8* zip = (u8*)malloc(zipSize);
 
                 if(zip)
                 {
-                    if(zipSize = tic_tool_zip(zip, zipSize, cart, cartSize))
+                    compress2(zip, &zipSize, cart, cartSize, Z_BEST_COMPRESSION);
+
                     {
                         EmbedHeader header = 
                         {
@@ -1947,7 +1937,6 @@ static void* embedCart(Console* console, s32* size)
                     free(zip);
                 }
             }
-            else printError(console, CodeSizeError);
 
             free(cart);
         }
@@ -2085,17 +2074,9 @@ static void onConsoleExportHtmlCommand(Console* console)
             {
                 s32 cartSize = tic_core_save(&tic->cart, cart);
 
-                if(cartSize)
-                {
-                    zip_entry_open(zip, "cart.tic");
-                    zip_entry_write(zip, cart, cartSize);
-                    zip_entry_close(zip);                    
-                }
-                else
-                {
-                    printError(console, CodeSizeError);
-                    errorOccured = true;
-                }
+                zip_entry_open(zip, "cart.tic");
+                zip_entry_write(zip, cart, cartSize);
+                zip_entry_close(zip);
 
                 free(cart);
             }
@@ -2110,20 +2091,14 @@ static void onConsoleExportHtmlCommand(Console* console)
                 #include "../build/assets/embed.html.dat"
             };
 
-            enum {HtmlSize = 10*1024}; // 10K
-            u8* data = calloc(1, HtmlSize);
+            u8* data = NULL;
+            s32 size = unzip(&data, Html, sizeof Html);
 
             if(data)
             {
-                s32 size = tic_tool_unzip(data, HtmlSize, Html, sizeof Html);
-
-                if(size)
-                {
-                    zip_entry_open(zip, "index.html");
-                    zip_entry_write(zip, data, size);
-                    zip_entry_close(zip);
-                }
-                else errorOccured = true;
+                zip_entry_open(zip, "index.html");
+                zip_entry_write(zip, data, size);
+                zip_entry_close(zip);
 
                 free(data);
             }
@@ -3096,15 +3071,13 @@ static bool cmdLoadCart(Console* console, const char* name)
     {
         if(hasProjectExt(name))
         {
-            if(loadProject(console, name, data, size, console->embed.file))
-            {
-                char cartName[TICNAME_MAX];
-                fsFilename(name, cartName);
-                setCartName(console, cartName);
-                console->embed.yes = true;
-                console->skipStart = true;
-                done = true;
-            }            
+            loadProject(console, name, data, size, console->embed.file);
+            char cartName[TICNAME_MAX];
+            fsFilename(name, cartName);
+            setCartName(console, cartName);
+            console->embed.yes = true;
+            console->skipStart = true;
+            done = true;
         }
         else if(tic_tool_has_ext(name, CART_EXT))
         {
@@ -3446,17 +3419,13 @@ void initConsole(Console* console, tic_mem* tic, FileSystem* fs, Config* config,
                 {
                     if(appSize == header->appSize + sizeof(EmbedHeader) + header->cartSize)
                     {
-                        u8* data = calloc(1, sizeof(tic_cartridge));
+                        u8* data = NULL;
+                        s32 dataSize = unzip(&data, app + header->appSize + sizeof(EmbedHeader), header->cartSize);
 
                         if(data)
                         {
-                            s32 dataSize = tic_tool_unzip(data, sizeof(tic_cartridge), app + header->appSize + sizeof(EmbedHeader), header->cartSize);
-
-                            if(dataSize)
-                            {
-                                tic_core_load(console->embed.file, data, dataSize);
-                                console->embed.yes = true;                                
-                            }
+                            tic_core_load(console->embed.file, data, dataSize);
+                            console->embed.yes = true;
                             
                             free(data);
                         }
diff --git a/src/studio.c b/src/studio.c
index bfe85255e..19897da3e 100644
--- a/src/studio.c
+++ b/src/studio.c
@@ -42,6 +42,7 @@
 #include "ext/gif.h"
 #include "ext/md5.h"
 
+#include <zlib.h>
 #include <ctype.h>
 
 #include <lua.h>
@@ -83,14 +84,6 @@ static const EditorMode Modes[] =
     TIC_MUSIC_MODE,
 };
 
-static const EditorMode BankModes[] =
-{
-    TIC_SPRITE_MODE,
-    TIC_MAP_MODE,
-    TIC_SFX_MODE,
-    TIC_MUSIC_MODE,
-};
-
 static struct
 {
     Studio studio;
@@ -124,13 +117,14 @@ static struct
         {
             struct
             {
+                s8 code;
                 s8 sprites;
                 s8 map;
                 s8 sfx;
                 s8 music;
             } index;
 
-            s8 indexes[COUNT_OF(BankModes)];
+            s8 indexes[COUNT_OF(Modes)];
         };
 
     } bank;
@@ -158,24 +152,23 @@ static struct
 
     struct
     {
-        Code*       code;
+        Code*   code;
+        Sprite* sprite;
+        Map*    map;
+        Sfx*    sfx;
+        Music*  music;
+    } editor[TIC_EDITOR_BANKS];
 
-        struct
-        {
-            Sprite* sprite[TIC_EDITOR_BANKS];
-            Map*    map[TIC_EDITOR_BANKS];
-            Sfx*    sfx[TIC_EDITOR_BANKS];
-            Music*  music[TIC_EDITOR_BANKS];
-        } banks;
-
-        Start*      start;
-        Console*    console;
-        Run*        run;
-        World*      world;
-        Config*     config;
-        Dialog*     dialog;
-        Menu*       menu;
-        Surf*       surf;
+    struct
+    {
+        Start* start;
+        Console* console;
+        Run* run;
+        World* world;
+        Config* config;
+        Dialog* dialog;
+        Menu* menu;
+        Surf* surf;
     };
 
     FileSystem* fs;
@@ -583,10 +576,10 @@ static void drawBankIcon(s32 x, s32 y)
     };
 
     bool over = false;
-    EditorMode mode = 0;
+    s32 mode = 0;
 
-    for(s32 i = 0; i < COUNT_OF(BankModes); i++)
-        if(BankModes[i] == impl.mode)
+    for(s32 i = 0; i < COUNT_OF(Modes); i++)
+        if(Modes[i] == impl.mode)
         {
             mode = i;
             break;
@@ -667,7 +660,7 @@ static void drawBankIcon(s32 x, s32 y)
                 }
             }
 
-            drawBitIcon(rect.x, rect.y, PinIcon, impl.bank.chained ? tic_color_2 : over ? tic_color_14 : tic_color_13);
+            drawBitIcon(rect.x, rect.y, PinIcon, impl.bank.chained || over ? tic_color_2 : tic_color_13);
         }
     }
     else
@@ -791,13 +784,12 @@ void drawToolbar(tic_mem* tic, bool bg)
 
 #if defined (TIC80_PRO)
     enum {TextOffset = (COUNT_OF(Modes) + 2) * Size - 2};
-    if(mode >= 1)
-        drawBankIcon(COUNT_OF(Modes) * Size + 2, 0);
+    drawBankIcon(COUNT_OF(Modes) * Size + 2, 0);
 #else
     enum {TextOffset = (COUNT_OF(Modes) + 1) * Size};
 #endif
 
-    if(mode == 0 || (mode >= 1 && !impl.bank.show))
+    if(mode >= 0 && !impl.bank.show)
     {
         if(strlen(impl.tooltip.text))
         {
@@ -816,31 +808,31 @@ void setStudioEvent(StudioEvent event)
     {
     case TIC_CODE_MODE:     
         {
-            Code* code = impl.code;
+            Code* code = impl.editor[impl.bank.index.code].code;
             code->event(code, event);           
         }
         break;
     case TIC_SPRITE_MODE:   
         {
-            Sprite* sprite = impl.banks.sprite[impl.bank.index.sprites];
+            Sprite* sprite = impl.editor[impl.bank.index.sprites].sprite;
             sprite->event(sprite, event); 
         }
     break;
     case TIC_MAP_MODE:
         {
-            Map* map = impl.banks.map[impl.bank.index.map];
+            Map* map = impl.editor[impl.bank.index.map].map;
             map->event(map, event);
         }
         break;
     case TIC_SFX_MODE:
         {
-            Sfx* sfx = impl.banks.sfx[impl.bank.index.sfx];
+            Sfx* sfx = impl.editor[impl.bank.index.sfx].sfx;
             sfx->event(sfx, event);
         }
         break;
     case TIC_MUSIC_MODE:
         {
-            Music* music = impl.banks.music[impl.bank.index.music];
+            Music* music = impl.editor[impl.bank.index.music].music;
             music->event(music, event);
         }
         break;
@@ -917,7 +909,7 @@ void drawBitIcon16(tic_mem* tic, s32 x, s32 y, const u16* ptr, u8 color)
 
 static void initWorldMap()
 {
-    initWorld(impl.world, impl.studio.tic, impl.banks.map[impl.bank.index.map]);
+    initWorld(impl.world, impl.studio.tic, impl.editor[impl.bank.index.map].map);
 }
 
 static void initRunMode()
@@ -1129,14 +1121,13 @@ static void initModules()
 
     resetBanks();
 
-    initCode(impl.code, impl.studio.tic, &tic->cart.code);
-
     for(s32 i = 0; i < TIC_EDITOR_BANKS; i++)
     {
-        initSprite(impl.banks.sprite[i], impl.studio.tic, &tic->cart.banks[i].tiles);
-        initMap(impl.banks.map[i], impl.studio.tic, &tic->cart.banks[i].map);
-        initSfx(impl.banks.sfx[i], impl.studio.tic, &tic->cart.banks[i].sfx);
-        initMusic(impl.banks.music[i], impl.studio.tic, &tic->cart.banks[i].music);
+        initCode(impl.editor[i].code, impl.studio.tic, &tic->cart.code);
+        initSprite(impl.editor[i].sprite, impl.studio.tic, &tic->cart.banks[i].tiles);
+        initMap(impl.editor[i].map, impl.studio.tic, &tic->cart.banks[i].map);
+        initSfx(impl.editor[i].sfx, impl.studio.tic, &tic->cart.banks[i].sfx);
+        initMusic(impl.editor[i].music, impl.studio.tic, &tic->cart.banks[i].music);
     }
 
     initWorldMap();
@@ -1422,7 +1413,7 @@ static void processShortcuts()
         else if(keyWasPressedOnce(tic_key_f11)) goFullscreen();
         else if(keyWasPressedOnce(tic_key_escape))
         {
-            Code* code = impl.code;
+            Code* code = impl.editor[impl.bank.index.code].code;
 
             if(impl.mode == TIC_CODE_MODE && code->mode != TEXT_EDIT_MODE)
             {
@@ -1475,7 +1466,7 @@ static void updateStudioProject()
     }
 
     {
-        Code* code = impl.code;
+        Code* code = impl.editor[impl.bank.index.code].code;
         impl.console->codeLiveReload.reload(impl.console, code->src);
         if(impl.console->codeLiveReload.active && code->update)
             code->update(code);
@@ -1617,31 +1608,31 @@ static void renderStudio()
     case TIC_RUN_MODE:      impl.run->tick(impl.run); break;
     case TIC_CODE_MODE:     
         {
-            Code* code = impl.code;
+            Code* code = impl.editor[impl.bank.index.code].code;
             code->tick(code);
         }
         break;
     case TIC_SPRITE_MODE:   
         {
-            Sprite* sprite = impl.banks.sprite[impl.bank.index.sprites];
+            Sprite* sprite = impl.editor[impl.bank.index.sprites].sprite;
             sprite->tick(sprite);       
         }
         break;
     case TIC_MAP_MODE:
         {
-            Map* map = impl.banks.map[impl.bank.index.map];
+            Map* map = impl.editor[impl.bank.index.map].map;
             map->tick(map);
         }
         break;
     case TIC_SFX_MODE:
         {
-            Sfx* sfx = impl.banks.sfx[impl.bank.index.sfx];
+            Sfx* sfx = impl.editor[impl.bank.index.sfx].sfx;
             sfx->tick(sfx);
         }
         break;
     case TIC_MUSIC_MODE:
         {
-            Music* music = impl.banks.music[impl.bank.index.music];
+            Music* music = impl.editor[impl.bank.index.music].music;
             music->tick(music);
         }
         break;
@@ -1674,7 +1665,7 @@ static void updateSystemFont()
 
 void studioConfigChanged()
 {
-    Code* code = impl.code;
+    Code* code = impl.editor[impl.bank.index.code].code;
     if(code->update)
         code->update(code);
 
@@ -1683,6 +1674,32 @@ void studioConfigChanged()
     getSystem()->updateConfig();
 }
 
+u32 unzip(u8** dest, const u8* source, size_t size)
+{
+    // TODO: remove this size
+    enum{DestSize = 10*1024*1024};
+
+    unsigned long destSize = DestSize;
+
+    u8* buffer = (u8*)malloc(destSize);
+
+    if(buffer)
+    {
+        if(uncompress(buffer, &destSize, source, (unsigned long)size) == Z_OK)
+        {
+            *dest = (u8*)malloc(destSize+1);
+            memcpy(*dest, buffer, destSize);
+            (*dest)[destSize] = '\0';
+        }
+
+        free(buffer);
+
+        return destSize;
+    }
+
+    return 0;
+}
+
 static void initKeymap()
 {
     FileSystem* fs = impl.fs;
@@ -1750,7 +1767,7 @@ static void studioTick()
         {
         case TIC_SPRITE_MODE:
             {
-                Sprite* sprite = impl.banks.sprite[impl.bank.index.sprites];
+                Sprite* sprite = impl.editor[impl.bank.index.sprites].sprite;
                 overline = sprite->overline;
                 scanline = sprite->scanline;
                 data = sprite;
@@ -1758,7 +1775,7 @@ static void studioTick()
             break;
         case TIC_MAP_MODE:
             {
-                Map* map = impl.banks.map[impl.bank.index.map];
+                Map* map = impl.editor[impl.bank.index.map].map;
                 overline = map->overline;
                 scanline = map->scanline;
                 data = map;
@@ -1802,13 +1819,13 @@ static void studioClose()
     {
         for(s32 i = 0; i < TIC_EDITOR_BANKS; i++)
         {
-            free(impl.banks.sprite[i]);
-            free(impl.banks.map[i]);
-            free(impl.banks.sfx[i]);
-            free(impl.banks.music[i]);
+            free(impl.editor[i].code);
+            free(impl.editor[i].sprite);
+            free(impl.editor[i].map);
+            free(impl.editor[i].sfx);
+            free(impl.editor[i].music);
         }
 
-        free(impl.code);
         free(impl.start);
         free(impl.console);
         free(impl.run);
@@ -1846,13 +1863,13 @@ Studio* studioInit(s32 argc, char **argv, s32 samplerate, const char* folder, Sy
     {
         for(s32 i = 0; i < TIC_EDITOR_BANKS; i++)
         {
-            impl.banks.sprite[i]   = calloc(1, sizeof(Sprite));
-            impl.banks.map[i]      = calloc(1, sizeof(Map));
-            impl.banks.sfx[i]      = calloc(1, sizeof(Sfx));
-            impl.banks.music[i]    = calloc(1, sizeof(Music));
+            impl.editor[i].code     = calloc(1, sizeof(Code));
+            impl.editor[i].sprite   = calloc(1, sizeof(Sprite));
+            impl.editor[i].map      = calloc(1, sizeof(Map));
+            impl.editor[i].sfx      = calloc(1, sizeof(Sfx));
+            impl.editor[i].music    = calloc(1, sizeof(Music));
         }
 
-        impl.code       = calloc(1, sizeof(Code));
         impl.start      = calloc(1, sizeof(Start));
         impl.console    = calloc(1, sizeof(Console));
         impl.run        = calloc(1, sizeof(Run));
diff --git a/src/studio.h b/src/studio.h
index 322469eab..ec3eda85d 100644
--- a/src/studio.h
+++ b/src/studio.h
@@ -117,6 +117,7 @@ void setStudioMode(EditorMode mode);
 void resumeRunMode();
 EditorMode getStudioMode();
 void exitStudio();
+u32 unzip(u8** dest, const u8* source, size_t size);
 
 void str2buf(const char* str, s32 size, void* buf, bool flip);
 void toClipboard(const void* data, s32 size, bool flip);
diff --git a/src/tic.c b/src/tic.c
index 55441fb6f..ba90c9890 100644
--- a/src/tic.c
+++ b/src/tic.c
@@ -44,23 +44,22 @@
 
 typedef enum
 {
-    CHUNK_DUMMY,        // 0
-    CHUNK_TILES,        // 1
-    CHUNK_SPRITES,      // 2
-    CHUNK_COVER,        // 3
-    CHUNK_MAP,          // 4
-    CHUNK_CODE,         // 5
-    CHUNK_FLAGS,        // 6
-    CHUNK_TEMP2,        // 7
-    CHUNK_TEMP3,        // 8
-    CHUNK_SAMPLES,      // 9
-    CHUNK_WAVEFORM,     // 10
-    CHUNK_TEMP4,        // 11
-    CHUNK_PALETTE,      // 12
+    CHUNK_DUMMY,    // 0
+    CHUNK_TILES,    // 1
+    CHUNK_SPRITES,  // 2
+    CHUNK_COVER,    // 3
+    CHUNK_MAP,      // 4
+    CHUNK_CODE,     // 5
+    CHUNK_FLAGS,    // 6
+    CHUNK_TEMP2,    // 7
+    CHUNK_TEMP3,    // 8
+    CHUNK_SAMPLES,  // 9
+    CHUNK_WAVEFORM, // 10
+    CHUNK_TEMP4,    // 11
+    CHUNK_PALETTE,  // 12
     CHUNK_PATTERNS_DEP, // 13 - deprecated chunk
-    CHUNK_MUSIC,        // 14
-    CHUNK_PATTERNS,     // 15
-    CHUNK_CODE_ZIP,     // 16
+    CHUNK_MUSIC,    // 14
+    CHUNK_PATTERNS, // 15
 } ChunkType;
 
 typedef struct
@@ -1919,10 +1918,6 @@ void tic_core_load(tic_cartridge* cart, const u8* buffer, s32 size)
 
     bool paletteExists = false;
 
-    tic_code* code = calloc(TIC_BANKS, TIC_CODE_BANK_SIZE);
-
-    if(!code) return;
-
     while(buffer < end)
     {
         Chunk chunk;
@@ -1940,9 +1935,9 @@ void tic_core_load(tic_cartridge* cart, const u8* buffer, s32 size)
         case CHUNK_PATTERNS:    LOAD_CHUNK(cart->banks[chunk.bank].music.patterns); break;
         case CHUNK_PALETTE:     LOAD_CHUNK(cart->banks[chunk.bank].palette);        break;
         case CHUNK_FLAGS:       LOAD_CHUNK(cart->banks[chunk.bank].flags);          break;
-        case CHUNK_CODE:        LOAD_CHUNK(code->banks[chunk.bank].data);           break;
-        case CHUNK_CODE_ZIP:
-            tic_tool_unzip(cart->code.data, TIC_CODE_SIZE, buffer, chunk.size);
+        case CHUNK_CODE:        
+            if(chunk.bank == 0)
+                LOAD_CHUNK(cart->code);
             break;
         case CHUNK_COVER:
             LOAD_CHUNK(cart->cover.data);
@@ -1977,17 +1972,6 @@ void tic_core_load(tic_cartridge* cart, const u8* buffer, s32 size)
 
     #undef LOAD_CHUNK
 
-    // workaround to load code from banks
-    if(!strlen(cart->code.data))
-        for(s32 i = TIC_BANKS-1; i >= 0; i--)
-            if(strlen(code->banks[i].data))
-            {
-                strcat(cart->code.data, code->banks[i].data);
-                strcat(cart->code.data, "\n");
-            }
-
-    free(code);
-
     // workaround to support ancient carts without palette
     // load DB16 palette if it not exists
     if(!paletteExists)
@@ -2054,28 +2038,12 @@ s32 tic_core_save(const tic_cartridge* cart, u8* buffer)
         buffer = SAVE_CHUNK(CHUNK_FLAGS,    cart->banks[i].flags,           i);
     }
 
-    #undef SAVE_CHUNK
-
+    buffer = SAVE_CHUNK(CHUNK_CODE, cart->code, 0);
     buffer = saveFixedChunk(buffer, CHUNK_COVER, cart->cover.data, cart->cover.size, 0);
 
-    {
-        u8* zip = calloc(1, TIC_CODE_BANK_SIZE);
-
-        if(zip)
-        {
-            u32 zipSize = tic_tool_zip(zip, TIC_CODE_BANK_SIZE, cart->code.data, strlen(cart->code.data));
-
-            if(zipSize)
-                buffer = saveFixedChunk(buffer, CHUNK_CODE_ZIP, zip, zipSize, 0);
-
-            free(zip);
-
-            if(zipSize)
-                return (s32)(buffer - start);
-        }        
-    }
+    #undef SAVE_CHUNK
 
-    return 0;
+    return (s32)(buffer - start);
 }
 
 // copied from SDL2
diff --git a/src/tic.h b/src/tic.h
index 3167c1318..b1779ba99 100644
--- a/src/tic.h
+++ b/src/tic.h
@@ -83,13 +83,12 @@
 #define WAVE_VALUE_BITS 4
 #define WAVE_SIZE (WAVE_VALUES * WAVE_VALUE_BITS / BITS_IN_BYTE)
 
+#define TIC_CODE_SIZE (0x10000)
+
 #define TIC_BANK_BITS 3
 #define TIC_BANKS (1 << TIC_BANK_BITS)
 #define TIC_GAMEPADS (sizeof(tic80_gamepads) / sizeof(tic80_gamepad))
 
-#define TIC_CODE_BANK_SIZE (64 * 1024) // 64K
-#define TIC_CODE_SIZE (TIC_CODE_BANK_SIZE * TIC_BANKS) // in total 512K
-
 #define SFX_NOTES {"C-", "C#", "D-", "D#", "E-", "F-", "F#", "G-", "G#", "A-", "A#", "B-"}
 #define TIC_FONT_CHARS 256
 
@@ -347,13 +346,8 @@ typedef struct
     u8 data[TIC_SPRITESIZE * TIC_SPRITESIZE * TIC_PALETTE_BPP / BITS_IN_BYTE];
 } tic_tile;
 
-typedef union
+typedef struct
 {
-    struct
-    {
-        char data[TIC_CODE_BANK_SIZE];
-    } banks[TIC_BANKS];
-
     char data[TIC_CODE_SIZE];
 } tic_code;
 
diff --git a/src/tools.c b/src/tools.c
index 65d228684..2c91d661d 100644
--- a/src/tools.c
+++ b/src/tools.c
@@ -23,7 +23,6 @@
 #include "tools.h"
 
 #include <string.h>
-#include <zlib.h>
 
 extern void tic_tool_poke4(void* addr, u32 index, u8 value);
 extern u8 tic_tool_peek4(const void* addr, u32 index);
@@ -120,14 +119,4 @@ void tic_tool_set_track_row_sfx(tic_track_row* row, s32 sfx)
 {
     row->sfxhi = (sfx & 0b00100000) >> MUSIC_SFXID_LOW_BITS;
     row->sfxlow = sfx & 0b00011111;
-}
-
-u32 tic_tool_zip(u8* dest, size_t destSize, const u8* source, size_t size)
-{
-    return compress2(dest, (unsigned long*)&destSize, source, size, Z_BEST_COMPRESSION) == Z_OK ? destSize : 0;
-}
-
-u32 tic_tool_unzip(u8* dest, size_t destSize, const u8* source, size_t size)
-{
-    return uncompress(dest, (unsigned long*)&destSize, source, size) == Z_OK ? destSize : 0;
-}
+}
\ No newline at end of file
diff --git a/src/tools.h b/src/tools.h
index 401a7d34d..2d7a58924 100644
--- a/src/tools.h
+++ b/src/tools.h
@@ -22,8 +22,6 @@
 
 #pragma once
 
-#include <stddef.h>
-
 #include "tic.h"
 #include "ext/gif.h"
 
@@ -58,5 +56,4 @@ u32*    tic_tool_palette_blit(const tic_palette* src);
 bool    tic_tool_has_ext(const char* name, const char* ext);
 s32     tic_tool_get_track_row_sfx(const tic_track_row* row);
 void    tic_tool_set_track_row_sfx(tic_track_row* row, s32 sfx);
-u32     tic_tool_zip(u8* dest, size_t destSize, const u8* source, size_t size);
-u32     tic_tool_unzip(u8* dest, size_t bufSize, const u8* source, size_t size);
+
